﻿<%@ Page Language="C#" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="VirtualEarth._Default" %>

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" >
    <head runat="server">
        <title>Mapa de Localização de Agentes de Saude</title>
        <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
        <script type="text/javascript" src="http://ecn.dev.virtualearth.net/mapcontrol/mapcontrol.ashx?v=6.2"></script>
        <script type="text/javascript">
            var Mapa = null;
            function NovaPosicao(e) 
            {
                form1.txtPosicao.value = Mapa.GetCenter();      //Le as coordenadas centrais onde o usuário clicou
            }
            function NivelZoom(e)
            {
                form1.txtZoom.value = Mapa.GetZoomLevel();      //Le o atual nivel de zoom (1-17, sendo 1 mais distante)
            }
            function CarregaMapa(Latitude, Longitude, Zoom, Visualização)
            {
                 Mapa = new VEMap('MeuMapa');       //Instancia o objeto
                 Mapa.HideDashboard();
                 Mapa.AttachEvent("onmouseup", NovaPosicao);
                 Mapa.AttachEvent("onmousewheel", NivelZoom);
                 Mapa.LoadMap(new VELatLong(Latitude, Longitude), Zoom, Visualização, false);       //Carrega o objeto nas posições indicadas
                 form1.txtPosicao.value = Latitude.toString() + "," + Longitude.toString();
                 form1.txtZoom.value = Zoom.toString();
                 AdicionaVeiculo(-23.442606611886766, -46.52427792549135, 'MATRIZ', '');        //Adiciona a Matriz como ponto fixo
             }
            function AdicionaVeiculo(Latitude, Longitude, Nome, Descricao) 
            {
                var Veiculo = new VEShape(VEShapeType.Pushpin, new VELatLong(Latitude, Longitude));     //Instancia o objeto PIN
                Veiculo.SetTitle(Nome);     //Setas as propriedades para nome e descrição
                Veiculo.SetDescription(Descricao);
                if(Nome != "MATRIZ")
                    Veiculo.SetCustomIcon("<img src='user.ico' />");        //Indica com HTML comum o que será mostrado como "alfinete"
                Mapa.AddShape(Veiculo);     //Adiciona o objeto PIN ao mapa
            }
        </script>
        <style type="text/css">
            .style1
            {
                font-family: Arial, Helvetica, sans-serif;
                font-size: x-small;
            }
            #txtPosicao
            {
                width: 401px;
            }
        </style>
    </head>

    <body>
        <form id="form1" runat="server" >
        <p>
            <asp:Button ID="btnAtualiza" runat="server" onclick="btnAtualiza_Click" 
                Text="Atualiza Posições" />
            <asp:Button ID="btnRodoviario" runat="server" onclick="btnRodoviario_Click" 
                Text="Mapa Rodoviário" />
            <asp:Button ID="btnAerio" runat="server" onclick="btnAerio_Click" 
                Text="Mapa Aéreo" />
            <asp:Label ID="lblModo" runat="server" Text="Aéreo" Visible="False"></asp:Label>
            <br />
        </p>
            <div id='MeuMapa' style="position:relative; width:800px; height:500px;" runat="server">
            </div>
            <span class="style1">Ponto Geo central: <input id="txtPosicao" type="text" 
            name="txtPosicao" readonly="readonly" /></span>
            <span class="style1">Nivel de Zoom: <input id="txtZoom" type="text" 
            name="txtZoom" readonly="readonly" /></span>
        <br />
        <asp:ListBox ID="lstDistancias" runat="server" Rows="6" Width="803px">
        </asp:ListBox>
        </form>
        <asp:Literal ID="Literal1" runat="server"></asp:Literal>
    </body>
</html>
