﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace VirtualEarth
{
    public partial class _Default : System.Web.UI.Page
    {
        protected void Page_Load(object sender, EventArgs e)
        {
            if(!IsPostBack)
                AtualizaMapa();
        }

        protected void btnAtualiza_Click(object sender, EventArgs e)
        {
            AtualizaMapa();
        }

        protected void btnRodoviario_Click(object sender, EventArgs e)
        {
            lblModo.Text = "Rodoviário";
            AtualizaMapa();
        }

        protected void btnAerio_Click(object sender, EventArgs e)
        {
            lblModo.Text = "Aéreo";
            AtualizaMapa();
        }

        private void AtualizaMapa()
        {
            lstDistancias.Items.Clear();
            //Posição inicial do Mapa no Aeroporto de Guarulhos (inicio)
            string Centro = "-15.114552871944102, -46.0546875";
            if(Request["txtPosicao"] != null)
                if (Request["txtPosicao"].ToString().Length > 0)
                    Centro = Request["txtPosicao"].ToString();
            //Nivel de zoom default
            string Zoom = "4";
            if (Request["txtZoom"] != null)
                if (Request["txtZoom"].ToString().Length > 0)
                    Zoom = Request["txtZoom"].ToString();
            //Modo de visualização (h/r)
            string ModoVisualização;
            if (lblModo.Text == "Aéreo")
                ModoVisualização = "h";
            else
                ModoVisualização = "r";
            //Monta o Script do cliente que irá renderizar o mapa
            Literal1.Text = "<script Language=javascript>";
            Literal1.Text += "  CarregaMapa(" + Centro + ", " + Zoom + ", '" + ModoVisualização + "' );";
            //Carrega a posição dos veiculos a partir do webservice
            PosicaoGPS obj = new PosicaoGPS();
            List<PosicaoGPS.Posicoes> DadosVeiculos = obj.RetornaPosicoes();
            //Para cada veiculo executa o script do cliente Bing Maps, incluindo um PIN e a distancia da matriz na lista
            foreach (PosicaoGPS.Posicoes Dados in DadosVeiculos)
            {
                Literal1.Text += "AdicionaVeiculo(" + Dados.Latitude.ToString().Replace(",", ".") + ", " + Dados.Longitude.ToString().Replace(",", ".")
                    + ", '" + Dados.Veiculo + "', '" + Dados.Descricao + "');";
                lstDistancias.Items.Add(Dados.Veiculo + " --> " + Dados.DistanciaMatriz.ToString());
            }
            //Fecha o script do cliente
            Literal1.Text += "</script>";
        }
    }
}
