﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Services;
using System.Data;
using System.Data.SqlClient;
using Microsoft.SqlServer.Types;

namespace VirtualEarth
{
    // To allow this Web Service to be called from script, using ASP.NET AJAX, uncomment the following line. 
    // [System.Web.Script.Services.ScriptService]
    public class PosicaoGPS : System.Web.Services.WebService
    {

        public struct Posicoes
        {
            public string Veiculo;
            public string Descricao;
            public DateTime Atualizacao;
            public float Longitude;
            public float Latitude;
            public double DistanciaMatriz;
        }

        [WebMethod]
        public string InformaPosicao(int ID, float Longitude, float Latitude)
        {
            try
            {
                SqlConnection Conexao = new SqlConnection("Data Source=(local);Database=VirtualEarth;Integrated Security=SSPI");
                SqlCommand Comando = new SqlCommand();
                Comando.Connection = Conexao;
                Comando.CommandType = CommandType.StoredProcedure;
                Comando.CommandText = "PROC_GRAVAPOSICAO";
                Comando.Parameters.AddWithValue("@ID_VEICULO", ID);
                Comando.Parameters.AddWithValue("@LONGITUDE", Longitude);
                Comando.Parameters.AddWithValue("@LATITUDE", Latitude);
                Conexao.Open();
                Comando.ExecuteNonQuery();
                Conexao.Close();
                return "Ok";
            }
            catch (Exception Erro)
            {
                return Erro.Message + "\n" + Erro.StackTrace;
            }
        }

        [WebMethod]
        public List<Posicoes> RetornaPosicoes()
        {
            try
            {
                SqlConnection Conexao = new SqlConnection("Data Source=(local);Database=VirtualEarth;Integrated Security=SSPI");
                SqlCommand Comando = new SqlCommand();
                Comando.Connection = Conexao;
                Comando.CommandType = CommandType.StoredProcedure;
                Comando.CommandText = "PROC_LEPOSICAO";
                DataTable Dados = new DataTable();
                SqlDataAdapter LeDados = new SqlDataAdapter(Comando);
                LeDados.Fill(Dados);
                List<Posicoes> Posicoes = new List<Posicoes>();
                foreach (DataRow Linha in Dados.Rows)
                {
                    Posicoes DadosVeiculo;
                    DadosVeiculo.Veiculo = Linha["Veiculo"].ToString();     //Le o nome do veículo
                    DadosVeiculo.Descricao = Linha["Descricao"].ToString();     //Le o tipo do veiculo
                    DadosVeiculo.Atualizacao = (DateTime)Linha["UltimaPosicao"];    //Le a data da atualização
                    SqlGeography Localizacao = (SqlGeography)Linha["Localizacao"];  //Carrega as coordenadas
                    DadosVeiculo.Latitude = (float)Localizacao.Lat;     //Converte coordenadas em float
                    DadosVeiculo.Longitude = (float)Localizacao.Long;   
                    SqlGeography Matriz = (SqlGeography)Linha["Matriz"];   //Carrega as coordenadas Matriz
                    DadosVeiculo.DistanciaMatriz = (double)Localizacao.STDistance(Matriz);  //Calcula a distancia entre o veiculo e a Matriz
                    Posicoes.Add(DadosVeiculo);
                }
                return Posicoes;
            }
            catch (Exception Erro)
            {
                throw(Erro);
            }
        }
    }
}
